summaryrefslogtreecommitdiff
path: root/tests/mv/mv-special-1
diff options
context:
space:
mode:
Diffstat (limited to 'tests/mv/mv-special-1')
-rwxr-xr-xtests/mv/mv-special-197
1 files changed, 97 insertions, 0 deletions
diff --git a/tests/mv/mv-special-1 b/tests/mv/mv-special-1
new file mode 100755
index 0000000..4d7c697
--- /dev/null
+++ b/tests/mv/mv-special-1
@@ -0,0 +1,97 @@
+#! /bin/sh
+# Test "mv" with special files.
+
+# Copyright (C) 1998, 1999, 2000, 2002, 2004, 2005, 2006 Free Software
+# Foundation, Inc.
+
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; either version 2 of the License, or
+# (at your option) any later version.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
+# GNU General Public License for more details.
+
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
+# 02110-1301, USA.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ mv --version
+fi
+
+pwd=`pwd`
+tmp=mv-spec.$$
+trap 'status=$?; cd "$pwd" && exec 1>&2; rm -rf $tmp $other_partition_tmpdir && exit $status' 0
+trap '(exit $?); exit' 1 2 13 15
+
+. $srcdir/../other-fs-tmpdir
+. $srcdir/../envvar-check
+# Make sure we get English translations.
+. $srcdir/../lang-default
+
+if test -z "$other_partition_tmpdir"; then
+ (exit 77); exit 77
+fi
+
+null=mv-null
+dir=mv-dir
+
+framework_failure=0
+mkdir $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+rm -f $null || framework_failure=1
+mknod $null p || framework_failure=1
+test -p $null || framework_failure=1
+mkdir -p $dir/a/b/c $dir/d/e/f || framework_failure=1
+touch $dir/a/b/c/file1 $dir/d/e/f/file2 || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo '********************************************'
+ echo 'NOTICE: unable to create test prerequisites'
+ echo '********************************************'
+ # exit 77 here to indicate that we couldn't run the test.
+ # At least running on SunOS 4.1.4, using a directory NFS mounted
+ # from an OpenBSD system, the above mknod fails.
+ (exit 77); exit 77
+fi
+
+fail=0
+mv --verbose $null $dir $other_partition_tmpdir > out || fail=1
+# Make sure the files are gone.
+test -p $null && fail=1
+test -d $dir && fail=1
+# Make sure they were moved.
+test -p $other_partition_tmpdir/$null || fail=1
+test -d $other_partition_tmpdir/$dir/a/b/c || fail=1
+
+# POSIX says rename (A, B) can succeed if A and B are on different file systems,
+# so ignore chatter about when files are removed and copied rather than renamed.
+sed "
+ /^removed /d
+ s,$other_partition_tmpdir,XXX,
+" out | sort > out2
+
+cat <<EOF | sort > exp
+\`$null' -> \`XXX/$null'
+\`$dir' -> \`XXX/$dir'
+\`$dir/a' -> \`XXX/$dir/a'
+\`$dir/a/b' -> \`XXX/$dir/a/b'
+\`$dir/a/b/c' -> \`XXX/$dir/a/b/c'
+\`$dir/a/b/c/file1' -> \`XXX/$dir/a/b/c/file1'
+\`$dir/d' -> \`XXX/$dir/d'
+\`$dir/d/e' -> \`XXX/$dir/d/e'
+\`$dir/d/e/f' -> \`XXX/$dir/d/e/f'
+\`$dir/d/e/f/file2' -> \`XXX/$dir/d/e/f/file2'
+EOF
+
+cmp out2 exp || fail=1
+
+# cd $other_partition_tmpdir
+# ls -l -A -R $other_partition_tmpdir
+
+(exit $fail); exit $fail